#include "geo_rqueue.h"

geo_rqueue::geo_rqueue() {
	head_ = tail_ = 0;
	len_ = 0;
}

void geo_rqueue::enque(Packet *p) {
	p->next_ = 0;
	if(head_ == 0) {
		head_ = tail_ = p;
	}
	else {
		tail_->next_ = p;
		tail_ = p;
	}
	len_++;
	if(len_ > GEO_MAX_LEN)
		fprintf(stderr, "Warning: Routing Queue FULL!!\n");
}

Packet* geo_rqueue::deque() {
	Packet *p = head_;
	if(head_ == tail_) {
		head_ = tail_ = 0;
	}
	else {
		head_ = head_->next_;
	}
	if(p) len_--;
	return p;
}

bool geo_rqueue::isNotEmpty() {
	return len_;
}